<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaRouteTransferResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaRouteTransferResult extends AbstractStructArrayBase
{
    /**
     * The ViaRouteTransferResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaRouteTransferResult[]
     */
    public $ViaRouteTransferResult;
    /**
     * Constructor method for ArrayOfViaRouteTransferResult
     * @uses ArrayOfViaRouteTransferResult::setViaRouteTransferResult()
     * @param \StructType\ViaRouteTransferResult[] $viaRouteTransferResult
     */
    public function __construct(array $viaRouteTransferResult = array())
    {
        $this
            ->setViaRouteTransferResult($viaRouteTransferResult);
    }
    /**
     * Get ViaRouteTransferResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaRouteTransferResult[]|null
     */
    public function getViaRouteTransferResult()
    {
        return isset($this->ViaRouteTransferResult) ? $this->ViaRouteTransferResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViaRouteTransferResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViaRouteTransferResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViaRouteTransferResultForArrayConstraintsFromSetViaRouteTransferResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViaRouteTransferResultViaRouteTransferResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaRouteTransferResultViaRouteTransferResultItem instanceof \StructType\ViaRouteTransferResult) {
                $invalidValues[] = is_object($arrayOfViaRouteTransferResultViaRouteTransferResultItem) ? get_class($arrayOfViaRouteTransferResultViaRouteTransferResultItem) : sprintf('%s(%s)', gettype($arrayOfViaRouteTransferResultViaRouteTransferResultItem), var_export($arrayOfViaRouteTransferResultViaRouteTransferResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViaRouteTransferResult property can only contain items of type \StructType\ViaRouteTransferResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViaRouteTransferResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteTransferResult[] $viaRouteTransferResult
     * @return \ArrayType\ArrayOfViaRouteTransferResult
     */
    public function setViaRouteTransferResult(array $viaRouteTransferResult = array())
    {
        // validation for constraint: array
        if ('' !== ($viaRouteTransferResultArrayErrorMessage = self::validateViaRouteTransferResultForArrayConstraintsFromSetViaRouteTransferResult($viaRouteTransferResult))) {
            throw new \InvalidArgumentException($viaRouteTransferResultArrayErrorMessage, __LINE__);
        }
        if (is_null($viaRouteTransferResult) || (is_array($viaRouteTransferResult) && empty($viaRouteTransferResult))) {
            unset($this->ViaRouteTransferResult);
        } else {
            $this->ViaRouteTransferResult = $viaRouteTransferResult;
        }
        return $this;
    }
    /**
     * Add item to ViaRouteTransferResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteTransferResult $item
     * @return \ArrayType\ArrayOfViaRouteTransferResult
     */
    public function addToViaRouteTransferResult(\StructType\ViaRouteTransferResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaRouteTransferResult) {
            throw new \InvalidArgumentException(sprintf('The ViaRouteTransferResult property can only contain items of type \StructType\ViaRouteTransferResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViaRouteTransferResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaRouteTransferResult
     */
    public function getAttributeName()
    {
        return 'ViaRouteTransferResult';
    }
}
